
 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 
 import "Turbine.Gameplay"; 

 import "Homeopatix.Fisherman.Globals"
 import "Homeopatix.Fisherman.MinimizedIcon"
 import "Homeopatix.Fisherman.VindarPatch"
 import "Homeopatix.Fisherman.Commands"
 import "Homeopatix.Fisherman.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>Fisherman</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizeY = tostring(settings.minimizeY);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = settings.shortcutData_1;
   		settings.shortcutData_2 = settings.shortcutData_2;
   		settings.primaryWeapon = settings.primaryWeapon;
   		settings.secondaryWeapon = settings.secondaryWeapon;
   		settings.isFishRodEquiped = settings.isFishRodEquiped;
   		
   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "Fisherman_Settings", settings);
end

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
FishermanWindow=Turbine.UI.Lotro.GoldWindow(); 
FishermanWindow:SetSize(180,120); 
FishermanWindow:SetText(Strings.PluginName); 
FishermanWindow.Message=Turbine.UI.Label(); 
FishermanWindow.Message:SetParent(FishermanWindow); 
FishermanWindow.Message:SetSize(150,15); 
FishermanWindow.Message:SetPosition(FishermanWindow:GetWidth()/2 - 75, FishermanWindow:GetHeight()/2 + 40); 
FishermanWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
FishermanWindow.Message:SetText(Strings.PluginText); 
FishermanWindow:SetWantsKeyEvents(true);

function FishermanWindow:Closing(sender, args)
	settings.isWindowVisible = false;
end


FishermanWindow:SetPosition(settings.positionX, settings.positionY);

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, FishermanWindow:SetVisible(false));
settings.isWindowVisible = false;
SaveSettings();
MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- yel helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( FishermanWindow );
centerWindow:SetPosition( 51 ,FishermanWindow:GetHeight()/2 - 12);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( FishermanWindow );
centerWindow2:SetPosition( 89 ,FishermanWindow:GetHeight()/2 - 12);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------

settings.shortcutData_1 = "0x7000EE1E"; -- fishing
--settings.shortcutData_2 = "0x03170006E8F4CCCF,0x00000000"; -- canne a peche en lebthron
centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( 9, settings.shortcutData_1 ) );

if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, settings.shortcutData_2 ) );
end



------------------------------------------------------------------------------------------
-- mouse click handler
------------------------------------------------------------------------------------------
centerQS1.MouseEnter = function(sender, args)
	FishermanWindow.Message:SetText(""); 
	FishermanWindow.Message:SetText(Strings.PluginLoisir); 
end

centerQS2.MouseEnter = function(sender, args)
	FishermanWindow.Message:SetText("");
	FishermanWindow.Message:SetText(Strings.PluginCanneapeche); 
end

centerQS1.MouseLeave = function(sender, args)
	FishermanWindow.Message:SetText(Strings.PluginText);
end

centerQS2.MouseLeave = function(sender, args)
	FishermanWindow.Message:SetText(Strings.PluginText);
end

function GetTheWeapons()

	--
	
	local equipPrimaryWeapon = Turbine.Gameplay.LocalPlayer:GetInstance():GetEquipment();
	local equipSecondaryWeapon = Turbine.Gameplay.LocalPlayer:GetInstance():GetEquipment();
		
	-- primary weapon
	equipPrimaryWeapon = equipPrimaryWeapon:GetItem(16);	-- index 16 = primary weapon
	
	
	-- secondary weapon
	equipSecondaryWeapon = equipSecondaryWeapon:GetItem(17); -- index 17 = secondary weapon
	if(equipSecondaryWeapon ~= nil ) then
		settings.secondaryWeapon = equipSecondaryWeapon:GetName();
	end
	
	
	--Turbine.Shell.WriteLine(settings.primaryWeapon); 
	--Turbine.Shell.WriteLine(settings.secondaryWeapon); 

	SaveSettings();
end

centerQS2.MouseClick = function(sender, args)
	if(settings.isFishRodEquiped == false) then
		
		local equipPrimaryWeapon = Turbine.Gameplay.LocalPlayer:GetInstance():GetEquipment();
		equipPrimaryWeapon = equipPrimaryWeapon:GetItem(16);
		
		local tmp = Turbine.UI.Lotro.Quickslot();
		
		tmp = centerQS2:GetShortcut();
		tmp = tmp:GetData();
		
		settings.primaryWeapon = equipPrimaryWeapon:GetName();


		centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 2, equipPrimaryWeapon:SetShortcut() ) );
		
		settings.isFishRodEquiped = true;
		SaveSettings();
		
	else

	end
	
end

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end
centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_2 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------

centerQS1.MouseWheel = function(sender, args)
	settings.shortcutData_1 = tostring(""); 
	centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings(3);
end
centerQS2.MouseWheel = function(sender, args)
	settings.shortcutData_2 = tostring(""); 
	centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings(3);
end


------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------
FishermanWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		FishermanWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings();
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			FishermanWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			FishermanWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	FishermanWindow.PositionChanged = function( sender, args )
    	local x,y = FishermanWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end

				
	



